divert(-1)
###############################################################################
#				macros.m4
#
# Copyright (C) 1997 by Marco d'Itri <md@debian.org>.
# I hereby release this work under the GPL.
#
# Those macros are based on the hypermap.m4 file by Michael Shields.
# Adam P. Harris helped with some m4 magic.
#
###############################################################################

In general, Meta is always distinguished, and M-S-KEY is distinct from
M-KEY.  This is good news for Emacs users.  C-S-KEY is consistently
folded into C-KEY.

Shift is more loosely interpreted than the other modifiers; usually if
S-KEY has no special meaning, the action will be the same as KEY.
However, if M-KEY or H-KEY is undefined, nothing happens.

General usage is MACRO(KEYCODE, UNSHIFTED, SHIFTED).

TOP + the numeric keypad keys or a-f keys composes a character (like the
old AltGr did).

Finally, you can change the behavior of the Caps Lock, right Alt and
Controls with m4 command-line options like
`-DCAPSLOCK_K=Hyper -DLEFTCTRL_K=Control -DRIGHTCTRL_K=Control'
or `-DCAPSLOCK_K=Super'.

define(`CAPSLOCK_K', `Hyper')
d efine(`LEFTCTRL_K', `Super')

(you can d efine NOCAPS or SWAPCAPS)
d efine(`NOCAPS')

######################### HERE BEGIN THE REAL MACROS ##########################

# SWAPCAPS and NOCAPS overrides any definition for CAPSLOCK_K and LEFTCTRL_K
ifdef(`SWAPCAPS',
`define(`CAPSLOCK_K', `Control')
ifdef(`LEFTCTRL_K', , `define(`LEFTCTRL_K', `Caps_Lock')')',
`ifdef(`NOCAPS',
`define(`CAPSLOCK_K', `Control')',
`ifdef(`CAPSLOCK_K', , `define(`CAPSLOCK_K', `Caps_Lock')')')
ifdef(`LEFTCTRL_K', , `define(`LEFTCTRL_K', `Control')')')

# Set default values.
ifdef(`RIGHTCTRL_K', , `define(`RIGHTCTRL_K', `Control')')
ifdef(`LEFTALT_K', , `define(`LEFTALT_K', `Alt')')
ifdef(`RIGHTALT_K', , `define(`RIGHTALT_K', `AltGr')')

define(`top', `altgr')
We don't have a "Top" modifier, we directly assign AltGr to the key

# Figure out if any key is a Hyper key.  If so, define `hyper', both
# for usefulness and `ifdef' testability.
ifelse(CAPSLOCK_K, `Hyper', `define(`hyper', `ctrlr')',
       RIGHTALT_K, `Hyper', `define(`hyper', `ctrlr')',
       LEFTCTRL_K, `Hyper', `define(`hyper', `ctrlr')',
       RIGHTCTRL_K, `Hyper', `define(`hyper', `ctrlr')')
define(`Hyper', `CtrlR')	# 128

# Idem
ifelse(CAPSLOCK_K, `Super', `define(`super', `ctrll')',
       RIGHTALT_K, `Super', `define(`super', `ctrll')',
       LEFTCTRL_K, `Super', `define(`super', `ctrll')',
       RIGHTCTRL_K, `Super', `define(`super', `ctrll')')
define(`Super', `CtrlL')	# 64

# There are two spare modifiers. Maybe we should try Front and Greek? :-)
# ShiftR 32
# ShiftL 16

# We first undefine `shift', which only causes problems.
undefine(`shift')

*******************************************************************************
# This macro adds Control variations to a key.
define(`CONTROL',
`	control		keycode $1 = $2
shift	control		keycode $1 = $2
	control	alt	keycode $1 = Meta_$2
shift	control	alt	keycode $1 = Meta_$2')
define(`CONTROLMETA',
`	control	alt	keycode $1 = $2
shift	control	alt	keycode $1 = $2')

*******************************************************************************
define(`HYPER', `define(`arg3', `ifelse(`$#', 2, `$2', `$3')')`'ifdef(`hyper',
`		hyper	keycode $1 = $2
shift		hyper	keycode $1 = arg3', ``dnl'')')
# BUG: should be folded in HYPER, but I'm not able to use ifdef...
define(`CONTROLHYPER', ifdef(`hyper',
`	control	hyper	keycode $1 = $2
shift	control	hyper	keycode $1 = $2', ``dnl''))
define(`METAHYPER', ifdef(`hyper',
`		alt	hyper	keycode $1 = $2
shift		alt	hyper	keycode $1 = $2', ``dnl''))
define(`CONTROLMETAHYPER', ifdef(`hyper',
`	control	alt	hyper	keycode $1 = $2
shift	control	alt	hyper	keycode $1 = $2', ``dnl''))

*******************************************************************************
define(`TOP', ifdef(`top',
`		top	keycode $1 = $2
shift		top	keycode $1 = $2', ``dnl''))
define(`CONTROLTOP', ifdef(`top',
`	control	top	keycode $1 = $2
shift	control	top	keycode $1 = $2', ``dnl''))
define(`METATOP', ifdef(`top',
`	alt	top	keycode $1 = $2
shift	alt	top	keycode $1 = $2', ``dnl''))

*******************************************************************************
define(`SUPER', `define(`arg3', `ifelse(`$#', 2, `$2', `$3')')`'ifdef(`super',
`		super	keycode $1 = $2
shift		super	keycode $1 = arg3', ``dnl'')')
define(`CONTROLSUPER', ifdef(`super',
`	control	super	keycode $1 = $2
shift	control	super	keycode $1 = $2', ``dnl''))
define(`METASUPER', ifdef(`super',
`	meta	super	keycode $1 = $2
shift	meta	super	keycode $1 = $2', ``dnl''))

*******************************************************************************
define(`SIMPLE', `			keycode $1 = $2 $2')

*******************************************************************************
# KEY(KEYCODE, UNSHIFTED, SHIFTED, MODIF)
define(`KEY',
`			keycode $1 = $2	$3`'dnl
ifelse(`$4', `N', `',
`$4', `S', `
		alt	keycode $1 = Meta_$2', `
		alt	keycode $1 = Meta_$2
shift		alt	keycode $1 = Meta_$3')')

*******************************************************************************
# Special case for letters.  Best to be explicit.
define(`LETTER',
`			keycode $1 = `+'$2	`+'translit($2, `a-z', `A-Z')
		alt	keycode $1 = `Meta_'$2
shift		alt	keycode $1 = `Meta_'translit($2, `a-z', `A-Z')')
ifdef(`SUPER_KBD',
`		super	keycode $1 = `+'$2
shift		super	keycode $1 = `+'translit($2, `a-z', `A-Z')
CONTROL($1, Control_$2)')

*******************************************************************************
# For function keys.  Call here is FUNCTION(KEYCODE, FKEYNUM).
define(`BANKSIZE', 12)
define(`FUNCTION',
`			keycode $1 = `F'$2	`F'eval($2 + 10)
	control		keycode $1 = `F'$2
		altgr	keycode $1 = `Console_'eval($2 + BANKSIZE)
		alt	keycode $1 = `Console_'$2
	control	alt	keycode $1 = `Console_'$2
ifdef(`hyper',
`		hyper	keycode $1 = `F'eval($2 + BANKSIZE * 2)', `dnl')')

*******************************************************************************
# For the keypad digits.  KPDIGIT(KEYCODE, DIGIT).
define(`KPDIGIT',
`			keycode $1 = KP_$2	KP_$2
		alt	keycode $1 = Ascii_$2
shift		alt	keycode $1 = Ascii_$2
TOP($1, Hex_$2)')

# A special approximation:
define(`Meta_Return', `Meta_Control_m')

keymaps 0,1,4,5,8,9,12,13`'ifdef(`hyper', `,128,129,132,133,136,137,140,141')
################################## WARNING! ###################################
divert(0)dnl ############### END OF DIVERTED TEXT #############################

	keycode 42 = Shift		# left shift
ifdef(`hyper', `hyper	keycode 42 = Caps_Lock
')dnl
	keycode 54 = Shift		# right shift
ifdef(`hyper', `hyper	keycode 54 = Caps_Lock
')dnl

